﻿Imports Infragistics.Windows.DataPresenter

Public Class AnimalTypeControl
    Inherits ContentControl

    ' Shared constructor
    Shared Sub New()
        DefaultStyleKeyProperty.OverrideMetadata(GetType(AnimalTypeControl), New FrameworkPropertyMetadata(GetType(AnimalTypeControl)))
    End Sub

    Public Sub New()
    End Sub


    ' ImageSource property
    Public Shared ReadOnly ImageSourceProperty As DependencyProperty = _
                  DependencyProperty.Register("ImageSource", GetType(ImageSource), GetType(AnimalTypeControl))

    Public Property ImageSource() As ImageSource
        Get
            Return DirectCast(GetValue(ImageSourceProperty), ImageSource)
        End Get
        Set(ByVal value As ImageSource)
            SetValue(ImageSourceProperty, value)
        End Set
    End Property


    Private Sub AnimalTypeControl_Initialized(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Initialized
        Dim valueBinding As New Binding("Content")
        valueBinding.RelativeSource = RelativeSource.TemplatedParent
        Me.SetBinding(ContentControl.ContentProperty, valueBinding)

        Me.SetupControl()
    End Sub


    Private Sub SetupControl()
        Dim rec As DataRecord = TryCast(Me.DataContext, DataRecord)
        If rec IsNot Nothing Then
            Dim animal As Window1.Animal = TryCast(rec.DataItem, Window1.Animal)

            If animal IsNot Nothing Then
                Select Case animal.Type
                    Case "Bird"
                        Me.ImageSource = BitmapFrame.Create(New Uri("pack://application:,,,/GridPrinting;component/icons/Bird.jpg"))

                    Case "Mammal"
                        Me.ImageSource = BitmapFrame.Create(New Uri("pack://application:,,,/GridPrinting;component/icons/Mammal.jpg"))
                End Select

                'Me.ImageSource = BitmapFrame.Create(ImageStore.GetImageStream(animal.Type))
            End If
        End If
    End Sub

End Class
