﻿Imports System.Printing
Imports Infragistics.Windows.Reporting

Partial Public Class PrintPreviewDialog

    Private _report As Report
    Public Property Report() As Report
        Get
            Return Me._report
        End Get
        Private Set(ByVal value As Report)
            Me._report = value
        End Set
    End Property

    Public Sub New(ByVal report As Report)
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Store the passed in report.
        Me.Report = report

        ' Update the preview.
        Me.UpdatePreview()
    End Sub

    Private Sub UpdatePreview()
        ' Get the local default printer and attach it to the report settings.
        Dim printServer As New LocalPrintServer
        Me.Report.ReportSettings.PrintQueue = printServer.DefaultPrintQueue

        ' Set the page orientation.
        Me.Report.ReportSettings.PageOrientation = PageOrientation.Landscape

        ' Generate the preview.
        Me.ReportPreview.GeneratePreview(Me.Report, False, True)
    End Sub

End Class
