﻿Imports Infragistics.Windows.Reporting
Imports Infragistics.Windows.DataPresenter
Imports System.Collections.ObjectModel

Class Window1

    Private Sub Window1_Initialized(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Initialized
        Me.CreateFields()
        Me.CreateData()
    End Sub

    Private Sub PrintPreview_Click(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles PrintPreview.Click
        Dim section As New EmbeddedVisualReportSection(Me.Grid)

        Dim report As New Report
        report.Sections.Add(section)

        Dim dialog As New PrintPreviewDialog(report)
        dialog.Owner = Me
        dialog.ShowDialog()
    End Sub

    Private Sub CreateFields()
        Dim nameField As New UnboundField
        nameField.BindingPath = New PropertyPath("Name")
        nameField.Name = "Animal"

        Dim typeField As New UnboundField
        typeField.BindingPath = New PropertyPath("Type")
        typeField.Name = "Type"
        typeField.Settings = Me.CreateTypeFieldSettings

        Dim layout As New FieldLayout
        layout.Fields.Add(nameField)
        layout.Fields.Add(typeField)

        Me.Grid.FieldLayouts.Add(layout)
    End Sub

    Private Function CreateTypeFieldSettings() As FieldSettings
        Dim template As New ControlTemplate(GetType(CellValuePresenter))
        template.VisualTree = New FrameworkElementFactory(GetType(AnimalTypeControl))

        Dim cellStyle As New Style(GetType(CellValuePresenter))
        cellStyle.Setters.Add(New Setter(CellValuePresenter.TemplateProperty, template))

        Dim settings As New FieldSettings
        settings.CellValuePresenterStyle = cellStyle

        Return settings
    End Function

    Private Sub CreateData()
        Dim data As New Animals
        data.Add(New Animal("Bear", "Mammal"))
        data.Add(New Animal("Lion", "Mammal"))
        data.Add(New Animal("Rabbit", "Mammal"))
        data.Add(New Animal("Eagle", "Bird"))
        data.Add(New Animal("Dove", "Bird"))
        data.Add(New Animal("Sparrow", "Bird"))

        Me.Grid.DataSource = data
    End Sub


    Public Class Animals
        Inherits ObservableCollection(Of Animal)
    End Class

    Public Class Animal
        Public Sub New(ByVal name As String, ByVal type As String)
            Me.Name = name
            Me.Type = type
        End Sub

        Private _name As String
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                Me._name = value
            End Set
        End Property

        Private _type As String
        Public Property Type() As String
            Get
                Return Me._type
            End Get
            Set(ByVal value As String)
                Me._type = value
            End Set
        End Property
    End Class

End Class
